import axios from '@/http';
import { parseSvg } from '@meta2d/svg';
import { cdn } from './api';

export function filename(str: string) {
  const i = str.lastIndexOf('.');
  return str.substring(0, i);
}

export async function getFolders(name: string, isSvg?: boolean) {
  const path = 'v/' + name;
  const folders: any = await axios.post('/api/assets/folders', {
    path,
  });
  if (!folders) {
    return [];
  }

  const files: any = await axios.post('/api/assets/files', {
    path,
  });

  const results = [];
  for (const item of folders.list) {
    const list = [];
    for (const f of files.list) {
      if (f.indexOf(item) >= 0) {
        const elem: any = {
          name: filename(f.replace(path + '/' + item + '/', '')),
          image: cdn + '/' + f.replace('v/', ''),
          isSvg,
        };
        list.push(elem);
      }
    }

    results.push({ name: item, list });
  }

  return results;
}

export async function makeSvg(elem: any) {
  const svgDom: string = await axios.get(elem.image);
  let _svgDom = svgDom.replaceAll('#333;', '#fff;');
  elem.svg = _svgDom;
  elem.data = parseSvg(_svgDom);
}
